<document>

:@* <a href=opzet.html>Multimedia Authoring I</a> -- doelstellingen en eindtermen 

<p align=right>
<a href=http://www.cwi.nl/~alexb/links_from_vrml2000.html>VRML</a>
</p>

:@ <a href=mailto:alexb@cwi.nl,huang@cs.vu.nl,eliens@cs.vu.nl>Samenstellers</a>
<ul>
<li> <a href=mailto:alexb@cwi.nl>Alex van Ballegooij</a>
<li> <a href=mailto:huang@cs.vu.nl>Zhisheng Huang</a>
<li> <a href=eliens@cs.vu.nl>Anton Eliens</a>
</ul>

:@ Related courses
<ul>
<li> http://www.digitaledu.com/courses/vrmlintro.html -- VRML Intro
<li> http://home.hiwaay.net/~crispen/vrmlworks/tutorials/index.html -- Tutorials
<li> http://vienna.eas.asu.edu/~wagner/academic/vrml98/preface.html -- advanced
</ul>

:@+ Multimedia Authoring I -- VRML/Web3D course

:@ Objectives
By the end of the course students will have been introduced to
the ideas of virtual reality, and will have a working knowledge
of VRML and Java script, and able to design 3D multimedia virtual
world on the Web.

:@ Prerequisites
Essential: HTML, Introduction to Multimedia.
Desirable: Java Programming.


:@ Approach
We will strive for a thematic approach, that is
introduce the modeling principles and technologies underlying
VRML by means of motivating examples.
We will also indicate the relation  of VRML to other 
formalisms and computation mechanisms that inhabit te Web,
Java, Javascript, HTML and XML.
Each example will be accompanied by an explanation
of the constructs used, and a dissection of the points
of interest.
<p> 
The main focus will be on the practical work of the students.
They will have to make a number of assignments and give
a presentation at the end of the course.
The course will be completed by an oral exam.

:@- Course structure
<ol>
<li> <b>Introduction</b> -- principles and applications of VR,
basic geometry and links (both ways) to HTMLpages.
<br>Concepts:
geometry, translation, viewpoints
<br>Example: product demo with HTML interface
<li> <b>Animating objects</b> -- sensors, interpolators,
the event-model and basic scripting
<br>Concepts: routing and activation
<br>Example: coloring objects, replacing interpolator with scripts
<li> <b>Structuring 3D space</b> -- transforms, groupings
and abstractions (i.e. protos), possibly including appearance,
background
and lights.
<br>Concepts: cascading transforms
<br>Example: showroom, or product demo 
<li> <b>Animating viewpoints</b> -- avatars and viewpoints
<br>Concepts: vrml programming model
<br>Example: the bus, pushable crates
<li> <b>Towards immersive virtual worlds</b> --
the (blaxxun) HUD node, more sensors, the RIF interaction gadgets
<br>Concepts: navigation and interaction
<br>Example: the emotion disc
<li> <b>Complex geometry</b> -- advanced geometric nodes,
authoring issues, creation from script, vrmlgen?
<br>Concepts: vrml authoring
<br>Example: elements from lego world?
<li> <b>The future of VR(ML)</b> -- the EAI, X3D,
agent guides, information retrieval
<br>Concepts: creating advanced worlds
<br>Example: navigation by query
</ol>

:@ Remarks:
Note: care must be taken that a suffient part
of the (annotated) reference manual is treated,
in such a way that the students can do their
practical assignments

:@ Material
Due to the lack of suitable, up-to-date, material, we
will develop our own syllabus

:@ Assignments -- weekly
<p align=right><a href=vrml-opdrachten.html>suggesties</a></p>
<ol>
<li> simple world -- basic geometry, positioning, colors
<li> simple animation -- pendulum, bouncing ball, or flying objects
<li> complex realistic scene -- building (outdoor) or gallery (indoor)
<li> guided tour -- on campus, in museum, or product demo (based on example world, e.g. VU Campus)
<li> simple game -- pong, tic-tac-toe, memory
<li> eind opdracht
<li> eind opdracht
<li> eind opdracht
</ol>

:@ Recommended additional reading
<ul>
<li>
Rikk Carey and Gavin Bell,
The Annotated VRML 97 Reference,
Addison-Wesley Longman.

<li>
Jed Hartman, Josie Wernecke
"The VRML2.0 Handbook, building moving worlds on the Web",
Silicon Graphics, Inc., 1996.
<li>
ISO,
"VRML97:The Virtual Reality Modeling Language",
ISO/IEC 14772-1, 1997.
</ul>
</document>
